<?php
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin license screen of the plugin.
 */
?>

<?php
$klaviyo_premium_license = get_option( 'klaviyo_edd_license_key' );
$klaviyo_premium_status  = get_option( 'klaviyo_edd_license_status' );
$klaviyo_pro_class       = ( 'valid' === $klaviyo_edd_license_status ) ? '' : ' klaviyo-pro-option';
$klaviyo_api_key         = get_option( 'klaviyo_api_key' );
$klaviyo_private_api_key = get_option( 'klaviyo_private_api_key' );
?>

<h3><?php echo esc_html( __( 'Connect to Klaviyo', 'klaviyo-toolkit' ) ); ?></h3>
<?php
echo sprintf(
	'<p>%1$s <a href="%2$s">%3$s</a>.</p>',
	esc_html( __( 'Insert your Klaviyo public & private API keys below to connect. You can find them on your Klaviyo', 'klaviyo-toolkit' ) ),
	esc_url( 'https://www.klaviyo.com/settings/account/api-keys' ),
	esc_html__( 'account page', 'klaviyo-toolkit' )
);
?>
<table class="form-table table-klaviyo-api">
	<tr>
		<th scope="row">
			<label for="klaviyo_api_key"><strong><?php echo esc_html( __( 'Klaviyo Public API Key', 'klaviyo-toolkit' ) ); ?></strong></label>
			<?php if ( 'valid' !== $klaviyo_edd_license_status ) { ?>
				<span class="klaviyo-pro-label"><?php echo esc_html( __( 'Get License', 'klaviyo-toolkit' ) ); ?></span>
			<?php } ?>
			<p class="description"><?php echo esc_html( __( '6-7 characters long max.', 'klaviyo-toolkit' ) ); ?></p>
		</th>
		<td class="<?php echo esc_attr( $klaviyo_pro_class ); ?>">
			<input type="text" name="klaviyo_api_key" id="klaviyo_api_key"
				   value="<?php echo $klaviyo_api_key; ?>" <?php echo esc_attr( $klaviyo_disabled_class ); ?>>
		</td>
	</tr>
	<tr>
		<th scope="row">
			<label for="klaviyo_private_api_key"><strong><?php echo esc_html( __( 'Klaviyo Private API Key', 'klaviyo-toolkit' ) ); ?></strong></label>
			<?php if ( 'valid' !== $klaviyo_edd_license_status ) { ?>
				<span class="klaviyo-pro-label"><?php echo esc_html( __( 'Get License', 'klaviyo-toolkit' ) ); ?></span>
			<?php } ?>
			<p class="description"><?php echo esc_html( __( 'Starts with pk_', 'klaviyo-toolkit' ) ); ?></p>
		</th>
		<td class="<?php echo esc_attr( $klaviyo_pro_class ); ?>">
			<input type="password" name="klaviyo_private_api_key" id="klaviyo_private_api_key"
				   value="<?php echo $klaviyo_private_api_key; ?>" <?php echo esc_attr( $klaviyo_disabled_class ); ?>>
		</td>
	</tr>
</table>
<div class="klaviyo-admin-loader" style="display: none;"></div>
