<?php

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}

$tribe_klaviyo_instance = new KT_WC_Sub_Exporter();

// Trigger based on URL parameters
if (current_user_can('manage_options') && isset($_GET['export_wc_subscriptions']) && $_GET['export_wc_subscriptions'] == 'true') {
    $tribe_klaviyo_instance->show_export_progress();
}

if (current_user_can('manage_options') && isset($_GET['download_wc_subscriptions']) && $_GET['download_wc_subscriptions'] == 'true') {
    $tribe_klaviyo_instance->download_wc_subscriptions();
}
?>
<div class="kt-content-box">
    <h2><?php echo esc_html( __( 'Export WooCommerce Subscription Statuses (BETA)', 'klaviyo-toolkit' ) ); ?></h2>
    <p><?php echo esc_html( __( 'Select the products whose WooCommerce Subscription statuses you want to export to a CSV file for Klaviyo.' , 'klaviyo-toolkit' ) ); ?></p>
    <p><?php echo esc_html( __( 'Important: If no products are selected, all subscriptions will be exported. Be aware that exporting a large number of products or variations may result in a file too large for Klaviyo to import.' , 'klaviyo-toolkit' ) ); ?></p>
    <p>
        <strong><label for="subscription_products"><?php echo esc_html( __( 'Select subscription products to export:', 'klaviyo-toolkit' ) ); ?></label></strong>
    </p>
    <p>
    <select id="subscription_products" name="subscription_products[]" multiple="multiple" style="width: 100%;"></select>
    </p>

    <p>
        <button class="button button-primary export-subscriptions-button" <?php echo esc_attr( $klaviyo_disabled_class ); ?>><?php echo esc_html( __( 'Run Export', 'klaviyo-toolkit' ) ); ?></button>
        <?php if ( 'valid' !== $klaviyo_edd_license_status ) { ?>
            <span class="klaviyo-pro-label"><?php echo esc_html( __( 'Get License', 'klaviyo-toolkit' ) ); ?></span>
        <?php } ?>
    </p>
    <div class="export-progress-container" style="display:none;">
        <strong class="export-notice"><?php echo esc_html( __( 'Please stay on this page until your download link has been generated.', 'klaviyo-toolkit' ) ); ?></strong>
        <div id="exportProgressBar" style="width: 100%; background-color: #ddd;">
            <div class="progress-meter">0%</div>
        </div>
    </div>
</div>
