<?php

/**
 * Define the internationalization functionality
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @link       https://madebytribe.com
 * @since      1.0.0
 *
 * @package    Klaviyo_Toolkit
 * @subpackage Klaviyo_Toolkit/includes
 */

/**
 * Define the internationalization functionality.
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @since      1.0.0
 * @package    Klaviyo_Toolkit
 * @subpackage Klaviyo_Toolkit/includes
 * @author     Tribe Interactive <hello@madebytribe.com>
 */
class Klaviyo_Toolkit_i18n {


	/**
	 * Load the plugin text domain for translation.
	 *
	 * @since    1.0.0
	 */
	public function load_plugin_textdomain() {

		load_plugin_textdomain(
			'klaviyo-toolkit',
			false,
			dirname( dirname( plugin_basename( __FILE__ ) ) ) . '/languages/'
		);

	}



}
