(function($) {
	'use strict';

	$(document).ready(function() {
		
		// Capture Viewed Page Event
		if (klaviyoPublicAjax.klaviyo_viewed_page_enabled) {
			console.log('Viewed Page Event is enabled');
			if ($('body').hasClass('page')) {
				console.log('Page detected');
				var pageDetails = {
					action: 'klaviyo_viewed_page',
					url: window.location.href,
					email: klaviyoPublicAjax.user_email // Assuming you pass user email from PHP
				};
				console.log('Sending AJAX request:', pageDetails);
				$.post(klaviyoPublicAjax.ajaxurl, pageDetails, function(response) {
					console.log('AJAX response:', response);
				});
			}
		}

		// Capture Searched Site Event
		if (klaviyoPublicAjax.klaviyo_searched_site_enabled) {
			console.log('Searched Site Event is enabled');
			if ($('body').hasClass('search-results')) {
				console.log('Search results page detected');
				var searchQuery = new URLSearchParams(window.location.search).get('s');
				var searchDetails = {
					action: 'klaviyo_searched_site',
					query: searchQuery,
					email: klaviyoPublicAjax.user_email // Assuming you pass user email from PHP
				};
				console.log('Sending AJAX request for search:', searchDetails);
				$.post(klaviyoPublicAjax.ajaxurl, searchDetails, function(response) {
					console.log('AJAX response:', response);
				});
			}
		}
		
		// Capture Viewed Product Category Event
		if (klaviyoPublicAjax.klaviyo_viewed_pro_cat_enabled) {
			console.log('Viewed Product Category Event is enabled');
			if ($('body').hasClass('tax-product_cat')) {
				console.log('Product category page detected');
				var categoryDetails = {
					action: 'klaviyo_viewed_pro_cat',
					categoryID: klaviyoPublicAjax.categoryID,
					categoryName: klaviyoPublicAjax.categoryName,
					imageURL: klaviyoPublicAjax.imageURL,
					url: window.location.href,
					email: klaviyoPublicAjax.user_email // Assuming you pass user email from PHP
				};
				console.log('Sending AJAX request for product category:', categoryDetails);
				$.post(klaviyoPublicAjax.ajaxurl, categoryDetails, function(response) {
					console.log('AJAX response:', response);
				});
			}
		}
		
		// Capture Viewed Post Event
		if (klaviyoPublicAjax.klaviyo_viewed_post_enabled) {
			console.log('Viewed Post Event is enabled');
			if ($('body').hasClass('single-post')) {
				console.log('Post detected');
				var postDetails = {
					action: 'klaviyo_viewed_post',
					postID: klaviyoPublicAjax.postID,
					postTitle: klaviyoPublicAjax.postTitle,
					postCategories: klaviyoPublicAjax.postCategories,
					imageURL: klaviyoPublicAjax.imageURL,
					url: window.location.href,
					email: klaviyoPublicAjax.user_email // Assuming you pass user email from PHP
				};
				console.log('Sending AJAX request for post:', postDetails);
				$.post(klaviyoPublicAjax.ajaxurl, postDetails, function(response) {
					console.log('AJAX response:', response);
				});
			}
		}

	});

})(jQuery);